#!/sbin/sh

#Build config file
CONFIGFILE="/tmp/elementalx.conf"

#VIBRATION
echo -e "\n\n##### Global Vibration Strength #####" >> $CONFIGFILE
echo -e "Enter vibration strength (0 to 100).  Default is 63.\n" >> $CONFIGFILE
echo "GVIB=63" >> $CONFIGFILE;

#S2W
SR=`grep "item.1.1" /tmp/aroma/gest.prop | cut -d '=' -f2`
SL=`grep "item.1.2" /tmp/aroma/gest.prop | cut -d '=' -f2`
SU=`grep "item.1.3" /tmp/aroma/gest.prop | cut -d '=' -f2`
SD=`grep "item.1.4" /tmp/aroma/gest.prop | cut -d '=' -f2`
echo -e "\n\n##### Sweep2wake Settings #####\n# 0 to disable sweep2wake" >> $CONFIGFILE
echo -e "# 1 to enable sweep right" >> $CONFIGFILE
echo -e "# 2 to enable sweep left" >> $CONFIGFILE
echo -e "# 4 to enable sweep up" >> $CONFIGFILE
echo -e "# 8 to enable sweep down\n" >> $CONFIGFILE
echo -e "# For combinations, add values together (e.g. all gestures enabled = 15)\n" >> $CONFIGFILE
if [ $SL = 1 ]; then
  SL=2
fi
if [ $SU == 1 ]; then
  SU=4
fi
if [ $SD == 1 ]; then
  SD=8
fi  

S2W=$(( SL + SR + SU + SD ))
echo SWEEP2WAKE=$S2W >> $CONFIGFILE;


#DT2W
DT2W=`grep "item.1.5" /tmp/aroma/gest.prop | cut -d '=' -f2`
DT2WH=`grep "item.2.3" /tmp/aroma/gest.prop | cut -d '=' -f2`
echo -e "\n\n##### Doubletap2Wake Settings #####\n# 0 to disable doubletap2wake" >> $CONFIGFILE
echo -e "# 1 to enable doubletap2wake (default)\n# 2 to enabled doubletap2wake fullscreen\n" >> $CONFIGFILE
if [ $DT2W = 1 ] && [ $DT2WH = 1 ]; then
  echo "DT2W=1" >> $CONFIGFILE;
elif [ $DT2W = 1 ] && [ $DT2WH = 0 ]; then
  echo "DT2W=2" >> $CONFIGFILE;
else
  echo "DT2W=0" >> $CONFIGFILE;
fi

#WG vibration strength
VIB_STRENGTH=`grep "item.2.1" /tmp/aroma/gest.prop | cut -d '=' -f2`
echo -e "\n\n##### Wake Vibration Settings #####\n# Set vibration strength (0 to 90)" >> $CONFIGFILE
echo -e "# 0 to disable haptic feedback for gestures" >> $CONFIGFILE
echo -e "# 20 is default\n" >> $CONFIGFILE
if [ $VIB_STRENGTH = 1 ]; then
  echo "VIB_STRENGTH=20" >> $CONFIGFILE;
else
  echo "VIB_STRENGTH=0" >> $CONFIGFILE;
fi

#S2W/DT2W Power key toggle
PWR_KEY=`grep "item.2.2" /tmp/aroma/gest.prop | cut -d '=' -f2`
echo -e "\n\n##### Power Key Toggles S2W/DT2W #####\n# 0 to disable" >> $CONFIGFILE
echo -e "# 1 to enable\n" >> $CONFIGFILE
if [ $PWR_KEY = 1 ]; then
  echo "PWR_KEY=1" >> $CONFIGFILE;
else
  echo "PWR_KEY=0" >> $CONFIGFILE;
fi

#S2W/DT2W Timeout
if [ ! -e /tmp/aroma/timeout.prop ]; then
  echo "selected.0=1" > /tmp/aroma/timeout.prop;
fi

TIMEOUT=`cat /tmp/aroma/timeout.prop | cut -d '=' -f2`
echo -e "\n\n##### S2W/DT2W Timeout #####\n# 0 = disabled" >> $CONFIGFILE
echo -e "# Otherwise, specify number of minutes (default is 60)\n" >> $CONFIGFILE
if [ $TIMEOUT = 1 ]; then
  echo "TIMEOUT=0" >> $CONFIGFILE;
elif [ $TIMEOUT = 2 ]; then
  echo "TIMEOUT=5" >> $CONFIGFILE;
elif [ $TIMEOUT = 3 ]; then
  echo "TIMEOUT=15" >> $CONFIGFILE;
elif [ $TIMEOUT = 4 ]; then
  echo "TIMEOUT=30" >> $CONFIGFILE;
elif [ $TIMEOUT = 5 ]; then
  echo "TIMEOUT=60" >> $CONFIGFILE;
elif [ $TIMEOUT = 6 ]; then
  echo "TIMEOUT=90" >> $CONFIGFILE;
elif [ $TIMEOUT = 7 ]; then
  echo "TIMEOUT=120" >> $CONFIGFILE;
fi

#S2S
S2S=`grep selected.0 /tmp/aroma/s2s.prop | cut -d '=' -f2`
echo -e "\n\n##### Sweep2sleep Settings #####\n# 0 to disable sweep2sleep" >> $CONFIGFILE
echo -e "# 1 to enable sweep2sleep right" >> $CONFIGFILE
echo -e "# 2 to enable sweep2sleep left" >> $CONFIGFILE
echo -e "# 3 to enable sweep2sleep left and right\n" >> $CONFIGFILE
if [ $S2S = 2 ]; then
  echo "S2S=1" >> $CONFIGFILE;
elif [ $S2S = 3 ]; then
  echo "S2S=2" >> $CONFIGFILE;
elif [ $S2S = 4 ]; then
  echo "S2S=3" >> $CONFIGFILE;
else
  echo "S2S=0" >> $CONFIGFILE;
fi

#USB Fastcharge
FC=`grep "item.0.1=" /tmp/aroma/mods.prop | cut -d '=' -f2`
echo -e "\n\n##### Fastcharge Settings ######\n# 1 to enable usb fastcharge\n# 0 to disable usb fastcharge\n" >> $CONFIGFILE
if [ $FC = 1 ]; then
  echo "FC=1" >> $CONFIGFILE;
else
  echo "FC=0" >> $CONFIGFILE;
fi

#Max screen off frequency
MAXSCROFF=`grep "item.0.2" /tmp/aroma/mods.prop | cut -d '=' -f2`
echo -e "\n\n##### Max screen off frequency #####\n# 0 to disable Max screen off frequency" >> $CONFIGFILE
echo -e "# 1 to enable Max screen off frequency\n" >> $CONFIGFILE
if [ $MAXSCROFF = 1 ]; then
  echo "MAXSCROFF=0" >> $CONFIGFILE;
else
  echo "MAXSCROFF=1" >> $CONFIGFILE;
fi

#Color
COLOR=`grep "item.0.3" /tmp/aroma/mods.prop | cut -d '=' -f2`
echo -e "\n\n##### Color Preset Settings #####\n# 0 for stock color" >> $CONFIGFILE
echo -e "# 1 for slightly cooler\n" >> $CONFIGFILE
if [ $COLOR = 1 ]; then
  echo "COLOR=1" >> $CONFIGFILE;
else
  echo "COLOR=0" >> $CONFIGFILE;
fi

#Graphics Boost
GBOOST=`grep "item.0.4" /tmp/aroma/mods.prop | cut -d '=' -f2`
echo -e "\n\n##### Graphics Boost Settings ######\n# 1 to enable\n# 0 to disable\n" >> $CONFIGFILE
if [ $GBOOST = 1 ]; then
  echo "GBOOST=0" >> $CONFIGFILE;
else
  echo "GBOOST=1" >> $CONFIGFILE;
fi

#Backlight
BL=`grep "item.0.5" /tmp/aroma/mods.prop | cut -d '=' -f2`
echo -e "\n\n##### Backlight Settings #####\n# 0 to for stock backlight" >> $CONFIGFILE
echo -e "# 1 for dimmer backlight\n" >> $CONFIGFILE
if [ $BL = 1 ]; then
  echo "BL=1" >> $CONFIGFILE;
else
  echo "BL=0" >> $CONFIGFILE;
fi

#fsync
FSYNC=`grep "item.0.6" /tmp/aroma/mods.prop | cut -d '=' -f2`
echo -e "\n\n##### fsync Settings ######\n# 1 to enable (default)\n# 0 to disable\n" >> $CONFIGFILE
if [ $FSYNC = 1 ]; then
  echo "FSYNC=0" >> $CONFIGFILE;
else
  echo "FSYNC=1" >> $CONFIGFILE;
fi

#CPU Governor
CPU_GOV=`grep "item.0.7" /tmp/aroma/mods.prop | cut -d '=' -f2`
echo -e "\n\n##### CPU Governor Settings #####\n# 0 for stock ondemand" >> $CONFIGFILE
echo -e "# 1 for ElementalX governor\n" >> $CONFIGFILE
if [ $CPU_GOV = 1 ]; then
  echo "CPU_GOV=0" >> $CONFIGFILE;
else
  echo "CPU_GOV=1" >> $CONFIGFILE;
fi

#Hotplug
HOTPLUG=`grep "item.0.8" /tmp/aroma/mods.prop | cut -d '=' -f2`
echo -e "\n\n##### CPU Hotplug Settings #####\n# 0 for stock mpdecision\n# 1 for custom hotplugging (disables mpdecision)\n" >> $CONFIGFILE
if [ $HOTPLUG = 1 ]; then
  echo "HOTPLUG=1" >> $CONFIGFILE;
else
  echo "HOTPLUG=0" >> $CONFIGFILE;
fi

#i/o scheduler
SCHED=`grep selected.1 /tmp/aroma/disk.prop | cut -d '=' -f2`
echo -e "\n\n##### i/o Scheduler #####\n# 1 CFQ (stock)" >> $CONFIGFILE
echo -e "# 2 ROW\n# 3 deadline (default)\n# 4 FIOPS\n# 5 SIO\n# 6 BFQ\n" >> $CONFIGFILE
if [ $SCHED = 1 ]; then
  echo "SCHED=1" >> $CONFIGFILE;
elif [ $SCHED = 2 ]; then
  echo "SCHED=2" >> $CONFIGFILE;
elif [ $SCHED = 3 ]; then
  echo "SCHED=3" >> $CONFIGFILE;
elif [ $SCHED = 4 ]; then
  echo "SCHED=4" >> $CONFIGFILE;
elif [ $SCHED = 5 ]; then
  echo "SCHED=5" >> $CONFIGFILE;
elif [ $SCHED = 6 ]; then
  echo "SCHED=6" >> $CONFIGFILE;
fi

#Readahead buffer size
READAHEAD=`grep selected.2 /tmp/aroma/disk.prop | cut -d '=' -f2`
echo -e "\n\n##### Readahead Buffer Size #####\n# 128 (stock)" >> $CONFIGFILE
echo -e "# 256\n# 512\n# 1024\n" >> $CONFIGFILE
if [ $READAHEAD = 1 ]; then
  echo "READAHEAD=128" >> $CONFIGFILE;
elif [ $READAHEAD = 2 ]; then
  echo "READAHEAD=256" >> $CONFIGFILE;
elif [ $READAHEAD = 3 ]; then
  echo "READAHEAD=512" >> $CONFIGFILE;
elif [ $READAHEAD = 4 ]; then
  echo "READAHEAD=1024" >> $CONFIGFILE;
fi

#reinstall options
echo -e "\n\n\n\n##### Reinstall Options #####" >> $CONFIGFILE
echo -e "# These settings are only applied if you run the express installer" >> $CONFIGFILE

#Maximum CPU freqs
CPU0=$(cat /tmp/aroma/freq0.prop | cut -d '=' -f2)
if [ ! -e /tmp/aroma/freq1.prop ]; then
  cp /tmp/aroma/freq0.prop /tmp/aroma/freq1.prop;
  cp /tmp/aroma/freq0.prop /tmp/aroma/freq2.prop;
  cp /tmp/aroma/freq0.prop /tmp/aroma/freq3.prop;
fi
CPU1=$(cat /tmp/aroma/freq1.prop | cut -d '=' -f2)
CPU2=$(cat /tmp/aroma/freq2.prop | cut -d '=' -f2)
CPU3=$(cat /tmp/aroma/freq3.prop | cut -d '=' -f2)
echo -e "\n\n##### Max CPU Frequncies #####" >> $CONFIGFILE
echo -e "# 1=1498MHz 2=1728MHz 3=1958MHz" >> $CONFIGFILE
echo -e "# 4=2266MHz 5=2342MHz 6=2419MHz" >> $CONFIGFILE
echo -e "# 7=2496MHz 8=2573MHz 9=2650MHz" >> $CONFIGFILE
echo -e "# 10=2726MHz 11=2803MHz 12=2880MHz" >> $CONFIGFILE
echo -e "# 13=2957MHz" >> $CONFIGFILE
echo "CPU0=$CPU0" >> $CONFIGFILE;
echo "CPU1=$CPU1" >> $CONFIGFILE;
echo "CPU2=$CPU2" >> $CONFIGFILE;
echo "CPU3=$CPU3" >> $CONFIGFILE;


#set undervolting
UV=$(cat /tmp/aroma/uv.prop | cut -d '=' -f2)
echo -e "\n\n##### Undervolt Settings #####" >> $CONFIGFILE
echo -e "# 1=stock 2=750mV (default) 3=725mV\n# 4=700mV 5=675mV 6=650mV 7=625mV\n" >> $CONFIGFILE
echo "UV=$UV" >> $CONFIGFILE;


#set optimization level
OPT=$(grep selected.2 /tmp/aroma/cpu.prop | cut -d '=' -f2)
echo -e "\n\n##### L2/Bus Overclock Settings #####" >> $CONFIGFILE
echo -e "# 1=elementalx (default) 2=stock\n" >> $CONFIGFILE
echo "OPT=$OPT" >> $CONFIGFILE;

#thermal throttling
THERM=$(grep selected.3 /tmp/aroma/cpu.prop | cut -d '=' -f2)
echo -e "\n\n##### Thermal Settings #####" >> $CONFIGFILE
echo -e "# 1=elementalx (default) 2=cooler 3=stock (coolest)\n" >> $CONFIGFILE
echo "THERM=$THERM" >> $CONFIGFILE;

#insecure kernel
if [ `grep "item.0.9" /tmp/aroma/mods.prop | cut -d '=' -f2` = 1 ]; then
  echo -e "\n\n##### Insecure Kernel #####\n" >> $CONFIGFILE
  echo "INSECURE=1" >> $CONFIGFILE;
fi

echo -e "\n\n##############################" >> $CONFIGFILE
#END
